////////////////////////////////////////
// i n i t i a l    c o n s t a n t s //
// these values are specific          //
// for every gallery                  //
////////////////////////////////////////
var linkVisibles = 5;   // number of thumbs on preview list
var origScrollLink = 5; // number of thumbs for every jump
var ajaxUrl = 'http:';  // url for submitting server operations
var galleryFolder = 'somevalue'; // specific gallery folder
///////////////////////////////////////


var picturesThumb, fwd, rwd, sld, rst, stopTimeout, elements;
var scrollCount = -1;


var currCount = 0;
var l;
var stepIncrement = 6;
var increment;
var attempts = 0;



function getSelectedThumbPosition(thumb) {
	return (thumb.uid - picturesThumb[currCount].uid + currCount);
}

var cleanThumbsEffects = function() {
	if (!picturesThumb) return;
	for (var i=0; i < picturesThumb.length; i++) 
		picturesThumb[i].removeClass("highlightThumb");
	
};
var addThumbsEffects = function(bool) {
	if (!bool) cleanThumbsEffects();
	picturesThumb[scrollCount].addClass("highlightThumb");
};

var thumbEventFn =function(e){
	e.stop();
	var titleText;
	if (!e.target.alt)
		titleText = 'Varie';
	else
		titleText = e.target.alt;
	$('pictureTitle').set('html', titleText);
	$('pictureSelected').src = e.target.src;
	scrollCount = getSelectedThumbPosition(this);
	addThumbsEffects();
};

var rwdEventFn = function(e){
	if (e && e!="touch" && e.target.hasClass("hide")) return;
	if (e && e!="touch") e.stop();
	var i = 0, 
		toShow = currCount, 
		toHide = toShow + linkVisibles;
	while (i++ < origScrollLink) {
		toHide--;
		toShow--;
		//if (toHide >= 0 && toHide <= l)
		if (toShow >= 0)
			picturesThumb[toShow].style.display = "block";
		if (toHide <= l)
			picturesThumb[toHide].style.display = "none";
	}
	currCount = toShow;
	fwd.className = "";
	rwd.className = "";
	if (currCount <= 0){
		rwd.className = "hide";
		fwd.className = "only";	
		currCount=0;
	}
	if (e == "touch") {
		scrollCount = currCount + linkVisibles - 1;
		$('pictureTitle').set('html', picturesThumb[scrollCount].firstChild.alt);
		$('pictureSelected').src = picturesThumb[scrollCount].firstChild.src;
		addThumbsEffects();
	}
};
// variable that avoid propagation with ajax
var interruptor = 0;
		
var fwdEventFn = function(e){
	if (e && e!="touch" && e.target.hasClass("hide")) return;
	if (interruptor) return;
	interruptor = 1;
	var reqForm = new Request({
	   url: ajaxUrl ,
	   data: {'mode':'offset','value': increment, 'galleryFolder':galleryFolder},
	   
	   onComplete:function(response){
	   		if (response) {
	   			$('pictureContainer').set('html', $('pictureContainer').get('html')+response);
				initGallery();
	   		}
	   		increment += stepIncrement;
			var i = 0, 
			toHide = currCount, 
			toShow = toHide + linkVisibles;
			while (i++ < origScrollLink) {
				if (toHide <= l)
					picturesThumb[toHide].style.display = "none";
				if (toShow <= l)
					picturesThumb[toShow].style.display = "block";
				toHide++;
				toShow++;
			}
			currCount = toHide;
			rwd.className = "";
			if (toShow > l){
				rwd.className = "only";
				fwd.className = "hide";	
			}
			if (e == "touch") {
				scrollCount = currCount;
				$('pictureTitle').set('html', picturesThumb[currCount].firstChild.alt);
				$('pictureSelected').src = picturesThumb[currCount].firstChild.src;
				addThumbsEffects();
			}
			interruptor = 0;
	   }
	});
	//Send the form.
	reqForm.send();
	
};

var sldEventFn = function(e){
			e.stop();
		    stopTimeout = (!stopTimeout);
		    cleanThumbsEffects();	
			scrollSlide();
};
var restoreEventFn = function(e) {
	while (currCount >= linkVisibles)
		rwd.fireEvent('click', "touch");
	currCount = 0;
	scrollCount = 0;
	$('pictureTitle').set('html', picturesThumb[currCount].firstChild.alt);
	$('pictureSelected').src = picturesThumb[currCount].firstChild.src;
	addThumbsEffects();

};
function initGallery() {
	picturesThumb = $$('div.pictureThumb');
	fwd = $('forward');
	rwd = $('rewind');
	sld = $('slide');
	rst = $('restore');
	fwdOn = $('forwardOn');
	rwdOn = $('rewindOn');
	stepIncrement = linkVisibles + 2;
	if (!increment) increment = stepIncrement; 
	if (fwd && rwd) {
		l = picturesThumb.length -1;
		
		// start initialize	
		for (var i = l; i >= linkVisibles+currCount;  i--)
			picturesThumb[i].style.display = "none";
		
		rwd.className = "hide";
		fwd.className = "only";	
		
		if (l < linkVisibles)
			fwd.className = "hide";
		picturesThumb.addEvent('click', thumbEventFn);		
		
		fwd.addEvent('click', fwdEventFn);
		rwd.addEvent('click', rwdEventFn);
		rst.addEvent('click', restoreEventFn);
		sld.addEvent('click', sldEventFn);
			
		if (fwdOn) fwdOn.addEvent('click', touchForward);
		if (rwdOn) rwdOn.addEvent('click', touchRewind);
		
		return true;
	}
	return false;
}

function scrollSlide() { 
	
	if (scrollCount == -1) scrollCount = currCount;
	scrollCount++;
	if (fwd.className != "hide" && (scrollCount % linkVisibles) == 0) 
		fwd.fireEvent('click');
	if (!stopTimeout && picturesThumb[scrollCount]) {
		$('pictureSelectedContainer').tween('opacity', 1,0);
		$('pictureTitle').set('html', picturesThumb[scrollCount].firstChild.alt);
		$('pictureSelected').src = picturesThumb[scrollCount].firstChild.src;
		$('pictureSelectedContainer').tween('opacity', 0,1);
		setTimeout("scrollSlide()",2500);
	} else {
		stopTimeout=true;
		// reset of forward
		scrollCount--;
		addThumbsEffects(true);
	}
}

function touchForward() {
	if (scrollCount == -1) scrollCount = currCount;
	scrollCount++;
	if (fwd.className != "hide" && (scrollCount % linkVisibles) == 0) {
		interruptor = 0;
		fwd.fireEvent('click', "touch");
	} else
	{
		if (scrollCount > l) {scrollCount = l; return}
		$('pictureTitle').set('html', picturesThumb[scrollCount].firstChild.alt);
		$('pictureSelected').src = picturesThumb[scrollCount].firstChild.src;
		addThumbsEffects();
	}
}

function touchRewind() {
	if (scrollCount < 0) scrollCount = currCount;
	if ( scrollCount > 0  && (scrollCount % linkVisibles) == 0) {
		scrollCount--;
		rwd.fireEvent('click', "touch");
	} else
	{
		scrollCount--;
		if (scrollCount < 0) {scrollCount = 0;  return;}
		$('pictureTitle').set('html', picturesThumb[scrollCount].firstChild.alt);
		$('pictureSelected').src = picturesThumb[scrollCount].firstChild.src;
		addThumbsEffects();
	}	
}

window.addEvent('domready', function(){
	 
	if (initGallery()) {
		stopTimeout = true;
		// end initialize
	}
});

