<?php
$baseFolder = dirname ( __FILE__ );

// Function to implement if you want univocize 
// the items into single folders
function get_unique_id() {
	
	return "";
}

function get_xml_contents($galleryFolder = null) {
	global $baseFolder;
	$folder = $baseFolder;
	if (! is_null ( $galleryFolder ))
		$folder .= "/$galleryFolder";
	$uid = get_unique_id ();
	if (file_exists ( "$folder/$uid" )) {
		$gallery = simplexml_load_file ( "$folder/$uid/gallery.xml" );
		$config = simplexml_load_file ( "$folder/$uid/config.xml" );
	} else {
		$gallery = simplexml_load_file ( "$folder/gallery.xml" );
		$config = simplexml_load_file ( "$folder/config.xml" );
	}
	$contents = new stdClass ( );
	$contents->gallery = $gallery;
	$contents->config = $config;
	return $contents;
}
function put_xml_contents(&$object, $galleryFolder = null, $type = "a") {
	$type = strtolower ( $type );
	global $baseFolder;
	$folder = $baseFolder;
	if (! is_null ( $galleryFolder ))
		$folder .= "/$galleryFolder";
	$uid = get_unique_id ();
	if (! file_exists ( "$folder/$uid" ))
		mkdir ( "$folder/$uid" );
	
	if ($type == "a" || $type == "all" || $type == "gallery" || $type == "g") {
		
		$contents = $object->gallery->asXML ();
		$filename = "$folder/$uid/gallery.xml";
		if (! $handle = @fopen ( $filename, 'w' )) {
			return "Not accessible ($filename)";
		}
		if (@fwrite ( $handle, $contents ) === FALSE) {
			return "Not writable ($filename)";
		}
		@fclose ( $handle );
	}
	if ($type == "a" || $type == "all" || $type == "config" || $type == "c") {
		
		$contents = $object->config->asXML ();
		$filename = "$folder/$uid/config.xml";
		if (! $handle = @fopen ( $filename, 'w' )) {
			return "Not accessible ($filename)";
		}
		if (@fwrite ( $handle, $contents ) === FALSE) {
			return "Not writable ($filename)";
		}
		@fclose ( $handle );
	}
	return true;
}

function xml_to_array(&$xmlObj) {
	$array = array ();
	foreach ( $xmlObj as $el )
		$array [] = $el;
	return $array;
}

function get_thumbs_previews($galleryFolder = null, $idStart = 0, $gallery = null, $limit = 0) {
	if ($limit == 0 || is_null ( $gallery )) {
		$obj = get_xml_contents ( $galleryFolder );
		$gallery = xml_to_array ( $obj->gallery );
		$limit = $obj->config->preview;
	
	}
	if (! is_array ( $gallery ) || $idStart >= count ( $gallery ))
		return "";
	$cnt = $idStart + $limit;
	$cnt ++;
	if ($cnt > count ( $gallery ))
		$cnt = count ( $gallery );
	for($i = $idStart; $i < $cnt; $i ++) {
		$src = preg_replace ( "/'/", "&#39;", $gallery [$i]->src );
		$alt = preg_replace ( "/'/", "&#39;", $gallery [$i]->description );
		$out .= "<div class='pictureThumb' ><img src='$src' alt='$alt' /></div>";
	}
	return $out;
}
function get_base_gallery($galleryFolder = null) {
	$objConfig = get_xml_contents ( $galleryFolder );
	$fldr = (is_null ( $galleryFolder )) ? "" : $galleryFolder;
	$localuri = $objConfig->config->phpUrl;
	$limit = $objConfig->config->preview;
	$out .= "
	<script type='text/javascript'>
		linkVisibles = $limit;
		origScrollLink = $limit;
		ajaxUrl = '$localuri';
		galleryFolder = '$fldr';
	</script>
	";
	$forward = preg_replace ( "/'/", "&#39;", $objConfig->config->forward );
	$rewind = preg_replace ( "/'/", "&#39;", $objConfig->config->rewind );
	$restore = preg_replace ( "/'/", "&#39;", $objConfig->config->restore );
	$next = preg_replace ( "/'/", "&#39;", $objConfig->config->next );
	$previous = preg_replace ( "/'/", "&#39;", $objConfig->config->previous );
	$slide = preg_replace ( "/'/", "&#39;", $objConfig->config->slide );
	$firstSource = preg_replace ( "/'/", "&#39;", $objConfig->gallery->pictureThumb [0]->src );
	$firstDescr = preg_replace ( "/'/", "&#39;", $objConfig->gallery->pictureThumb [0]->description );
	$thumbs_div = get_thumbs_previews ( $galleryFolder, 0, xml_to_array ( $objConfig->gallery ) );
	$out .= include "template.php";
	return $out;
}
function print_base_gallery() {
	print get_base_gallery ();
}

///// test parameters


////
if (isset ( $_REQUEST ["mode"] )) {
	$mode = $_REQUEST ["mode"];
	$value = $_REQUEST ["value"];
	$galleryFld = (isset ( $_REQUEST ["galleryFolder"] )) ? $_REQUEST ["galleryFolder"] : null;
	
	if ($mode == "offset") {
		$_SESSION ["offset"] = (! isset ( $_SESSION ["offset"] )) ? intval ( $value ) : $_SESSION ["offset"] + intval ( $value );
		echo get_thumbs_previews ( $galleryFld, $_SESSION ["offset"] );
	}
	
	if ($mode == "read" && $value == "gallery") {
		$out = get_xml_contents ( $galleryFld );
		$out = json_encode ( $out->gallery );
		//$ln = strlen ( $out );
		//header ( "Content-Length:	$ln" );
		echo "$out";
	}
	if ($mode == "read" && $value == "config") {
		$out = get_xml_contents ( $galleryFld );
		$out = "{root:[" . json_encode ( $out->config ) . "]}";
		//$ln = strlen ( $out );
		//header ( "Content-Length:	$ln" );
		

		echo $out;
	}
	if ($mode == "write" && $value == "config") {
		$out = get_xml_contents ( $galleryFld );
		$out->config->forward = $_REQUEST ["forward"];
		$out->config->rewind = $_REQUEST ["rewind"];
		$out->config->restore = $_REQUEST ["restore"];
		$out->config->next = $_REQUEST ["next"];
		$out->config->previous = $_REQUEST ["previous"];
		$out->config->slide = $_REQUEST ["slide"];
		$out->config->preview = $_REQUEST ["preview"];
		// header ( "Content-Length: 1" );
		

		$echo = put_xml_contents ( $out, $galleryFld );
		if ($echo === TRUE)
			echo "1";
		else
			echo "0";
	
	}
	if ($mode == "write" && $value == "gallery") {
		$out = get_xml_contents ( $galleryFld );
		$out->gallery = simplexml_load_string ( "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<pictureContainer>
</pictureContainer>
" );
		$i = 0;
		while ( isset ( $_REQUEST ["record$i"] ) ) {
			$obj = json_decode ( preg_replace ( "/\\\\/", "", $_REQUEST ["record$i"] ), true );
			$thumb = $out->gallery->addChild ( 'pictureThumb' );
			$thumb->addChild ( 'src' );
			$thumb->addChild ( 'description' );
			$out->gallery->pictureThumb [$i]->src = $obj ["image"];
			$out->gallery->pictureThumb [$i]->description = $obj ["description"];
			$i ++;
		}
		//header ( "Content-Length: 1" );
		$echo = put_xml_contents ( $out, $galleryFld );
		if ($echo === TRUE)
			echo "1";
		else
			echo "0";
	}
}
?>
