Ext.onReady(function(){

        Ext.QuickTips.init();
    	var fm = Ext.form;
    	

        // this could be inline, but we want to define the Plant record
        // type so we can add records dynamically
        var recConfig = Ext.data.Record.create([
               {name: 'forward', type:'string'},
               {name: 'rewind', type:'string'},
               {name: 'restore', type:'string'},
               {name: 'previous', type:'string'},
               {name: 'next', type:'string'},
               {name: 'slide', type:'string'},
               {name: 'preview', type:'string'},
          ]);

        // create the Data Store
        var storeConfig = new Ext.data.Store({
            // load using HTTP
            //url:"http://localhost/sites/franco/testcmp01/config.xml",
            url: ajaxUrl,
            baseParams:{mode:'read', value:'config', galleryFolder: galleryFolder},
            // the return will be XML, so lets set up a reader
            reader: new Ext.data.JsonReader({
                   root: 'root'
               }, recConfig)
        });

       var forward = new fm.TextField({
                        xtype:'textfield',
                        fieldLabel: 'Text for forward visibles thumbs',
                        name: 'forward',
                        anchor:'85%'
       });
       var rewind = new fm.TextField({
           xtype:'textfield',
           fieldLabel: 'Text for rewind visibles thumbs',
           name: 'rewind',
           anchor:'85%'
       });
       var restore = new fm.TextField({
           xtype:'textfield',
           fieldLabel: 'Text for loop to begin of visibles thumbs',
           name: 'restore',
           anchor:'85%'
       });
       var next = new fm.TextField({
           xtype:'textfield',
           fieldLabel: 'Text for next picture',
           name: 'next',
           anchor:'85%'
       });
       var previous = new fm.TextField({
           xtype:'textfield',
           fieldLabel: 'Text for previous picture',
           name: 'previous',
           anchor:'85%'
       });
       var slide = new fm.TextField({
           xtype:'textfield',
           fieldLabel: 'Text for sliding picture',
           name: 'slide',
           anchor:'85%'
       });
       var preview = new Ext.form.NumberField({
    		fieldLabel: 'Number of pics in thumbs list',
    		allowDecimals: false,
    		allowBlank: false,
    		minValue:0,
    		maxValue: 10,
    		anchor:'60%',
           name: 'preview'
       });


       var hiddenWrite = new fm.Hidden({name:'mode', value:'write'});
       var hiddenConf = new fm.Hidden({name:'value', value:'config'});
       var hiddenFolder = new fm.Hidden({name:'galleryFolder', value:galleryFolder});
       
       var loadingItems = function(r,o,s)
       {
        if (r[0]) {
        var rec = r[0];
        forward.setValue(rec.get("forward"));
        rewind.setValue(rec.get("rewind"));
        restore.setValue(rec.get("restore"));
        next.setValue(rec.get("next"));
        previous.setValue(rec.get("previous"));
        slide.setValue(rec.get("slide"));
        preview.setValue(rec.get("preview"));
        }
       }
       
       function savingConfig(mode){

    		if (!configForm.getForm().isValid()) {
                Ext.MessageBox.alert('Warning','Some values are invalid. Review your form.');
    			return;
    		}
       		
    		
    		Ext.MessageBox.confirm('Warning','The operation can\'t be undone. Do you want to continue?', function(btn) {
    						if (btn == "no") return;
    						configForm.getForm().submit({
    						  success:function(f, o) {Ext.MessageBox.alert('Warning','Data saved correctly!',function(){storeConfig.load({callback:loadingItems})});},
    						  failure:function(f, o) {
    							  if (o.result===1) 
    								  	Ext.MessageBox.alert('Warning','Data saved correctly!',function(){storeConfig.load({callback:loadingItems})}); 
    							  else 
    								  Ext.MessageBox.alert('Warning','Data unsaved! Retry later..');
    							  }
    						});		
    			});
    	}


    	var configForm = new Ext.FormPanel({
    				    title: 'Config Form',
    				    margins:'0 0 0 0', 
    				    bodyStyle:'padding:10px',
    				    labelWidth: 290,
    				    url: ajaxUrl,
            			defaults: {msgTarget: 'under'},
    				    items:[forward, rewind,restore,next,previous,slide,preview, hiddenConf, hiddenWrite, hiddenFolder],
    					tbar:[
                			{
                				text: 'Save',
                				handler:function() {savingConfig('wc');}
                			}
    					]
    	});				   
    	

        
        

        
        // trigger the data store load
        var alreadyConfigLoaded = false;
        configForm.on("activate",function() {
    	    	if (!alreadyConfigLoaded)
    	    		storeConfig.load({callback:loadingItems});
    	    	alreadyConfigLoaded = true;
        	}
        );
        
    	// utilities
    	function replaceAll(from, search, replaced){
    		var toReturn = from.replace(search, replaced);
    		while (toReturn.indexOf(search) != -1)
    			toReturn = toReturn.replace(search, replaced);
    		return toReturn;
    	}

        // the column model has information about grid columns
        // dataIndex maps the column to the specific data field in
        // the data store (created below)
        var cmImage = new Ext.grid.ColumnModel(
        	[
             {
                 header: "Image",
                 dataIndex: 'image',
                 width: 120,
                 sortable:false,
                 editor: new fm.TextField({
                     allowBlank: false,
                     listeners:{change: function(t, n) {
                 		if (n && n.length >= 3)
                 			if (n.trim().toLowerCase().substring(0,3) == "www")
                 				t.setValue("http://"+n);
              
                 		}
                 	}
                 })
             },
            {
               header: "Description",
               dataIndex: 'description',
               width: 170,
               sortable:false,
               editor: new fm.TextField({
                   allowBlank: false
               })
            }
        ]);

        // by default columns are sortable
        cmImage.defaultSortable = true;

        // this could be inline, but we want to define the Plant record
        // type so we can add records dynamically
        var recImage = Ext.data.Record.create([
               {name: 'image', type: 'string', mapping:'src'},
               {name: 'description',   type: 'string', mapping:'description'}
          ]);

        // create the Data Store
        var storeImage = new Ext.data.Store({
            url: ajaxUrl,
            baseParams:{mode:"read", value:"gallery", galleryFolder: galleryFolder},
            // the return will be XML, so lets set up a reader
            reader: new Ext.data.JsonReader({
                   root: 'pictureThumb'
               }, recImage)

            // ,sortInfo:{field:'common', direction:'ASC'}
        });

    	
    	var imageSplittable = new Ext.Panel({
    				    title: 'Preview',
    				    region: 'center',
    		            collapsible: true,
    				    collapsed: false,
    				    margins:'0 0 0 0',
    				    cmargins:'0 0 0 0',
    				    html:"<div> </div>"	
    	});				   
    	

        
        // create the editor grid
        var gridImage = new Ext.grid.EditorGridPanel({
            cm: cmImage,
            store: storeImage,
			split: true,
			height:160,
            viewConfig:{forceFit:true},
            //autoExpandColumn:'title',
            title:'Gallery',
            frame:true,
            region:'north',
            clicksToEdit:1,
            autoload: true,
            sm: new Ext.grid.RowSelectionModel({singleSelect:true})
            
        });

        function selectionCurrentImage(sel){
        	var selRow = sel.getSelected();
        	if (selRow)
        		imageSplittable.body.update("<div class='overContainer'><img src='" + replaceAll(selRow.get("image"), "\\", "/") + "' /></div>");
        	else
        		imageSplittable.body.update("<div></div>");
        	imageSplittable.expand(true);
        	
        }
        gridImage.getSelectionModel().addListener('selectionchange', selectionCurrentImage);

    	var gridPaneImage = new Ext.Panel({
    	    title: 'Modify Gallery',
    		plain: true,
    		layout: 'border',
    		items: [imageSplittable, gridImage],
    		tbar: [{
                text: 'Add Image',
                tooltip: "Add a new Image to Gallery",
                handler : function(){
                    	var b = new recImage({
                        	image: 'http://',
                        	description: 'Nuova Descrizione'
                    	});
                    	gridImage.stopEditing();
                    	storeImage.insert(0, b);
                    	gridImage.getSelectionModel().selectFirstRow();
                    	gridImage.startEditing(0, 0);
                	}
            	},'-',
            	{
                    text: 'Reload',
                    tooltip: 'Reload all Images List. Value not saved will be lost.',
                    handler: function() {
    					Ext.MessageBox.confirm('Warning','Not saved values will be lost. Do you want continue?', function(btn) {
    						if (btn == "no") return;
    	        			storeImage.reload(); 
    					});
            		}
            		
            	},'-',
                {
                    text: 'Save data',
                    tooltip: 'Save all the data',
                    handler: function() {
    					Ext.MessageBox.confirm('Warning','This operation can\'t be undone. Do you want continue?', function(btn) {
    						if (btn == "no") return;
    						savingGridImage();
    					});
            		}
                },'-',
                {
                    text: 'Move down',
                    tooltip: 'Allows to move to the down row the selected picture',
                    handler: function() {
    	            	var rsel = gridImage.getSelectionModel();
    	            	if (rsel.hasSelection()){
    	            		var cur = rsel.getSelected();
    	            		if (rsel.selectNext(false)){
    	            			
    	            			var temp;
    	            			var oth = rsel.getSelected();
    	            			//rsel.selectPrevious(false);
    	            			
    	            			temp = oth.get('image');	oth.set('image', cur.get('image'));		cur.set('image', temp);
    	            			temp = oth.get('description');	oth.set('description', cur.get('description'));		cur.set('description', temp);
    	            		}
    	            	}
            		}
                },
                {
                    text: 'Move up',
                    tooltip: 'Allows to move to the up row the selected picture',
                    handler: function() {
    	            	var rsel = gridImage.getSelectionModel();
    	            	if (rsel.hasSelection()){
    	            		var cur = rsel.getSelected();
    	            		if (rsel.selectPrevious(false)){
    	            			
    	            			var temp;
    	            			var oth = rsel.getSelected();
    	            			//rsel.selectNext(false);
    	            			temp = oth.get('image');	oth.set('image', cur.get('image'));		cur.set('image', temp);
    	            			temp = oth.get('description');	oth.set('description', cur.get('description'));		cur.set('description', temp);
    	            		}
    	            	}
            		}
                }, '-', {
                	text: 'Delete',
                    tooltip: 'Delete current item',
                	handler: function() {
    				Ext.MessageBox.confirm('Warning','This operation can\'t be undone. Do you want continue?', function(btn) {
    					if (btn == 'no') return;
    					var rsel = gridImage.getSelectionModel();
    	            	if (rsel.hasSelection()){
    						storeImage.commitChanges();
    						if (storeImage.getCount() == 1) {
    							Ext.MessageBox.alert('Warning','You can\'t clear all the list');
    							return;
    						}
    	            		var cur = rsel.getSelected();
    	            		storeImage.remove(cur);
    	            	}
    				});
    	            	
            		}
                }
                
            ]
    	});				   
    	
        
        function savingGridImage(){
    		gridImage.suspendEvents();
    		storeImage.commitChanges();
    		var objParm = {};
    		objParm['mode'] = "write";
    		objParm['value'] = "gallery";
    		objParm['galleryFolder'] = galleryFolder;
    		var i = 0;
    		while (true) {
    			var thisRecord = storeImage.getAt(i);
    			if (!thisRecord) 
    				break;
    			objParm['record'+i] = Ext.util.JSON.encode(thisRecord.data);
    			i++;
    		}
    		
    		Ext.Ajax.request(
    				{   
    		            waitMsg: 'Data refresh...',
    		            url: ajaxUrl, ////// cambiare 
    		            params: objParm, 
    		            failure:function(response,options){
    		                Ext.MessageBox.alert('Warning','Saving failed',
    		                		function(){ storeImage.reload();}		
    		                );
    		                
    					},     
    		            
    		            success:function(response,options){
    		                Ext.MessageBox.alert('Information','The images are saved correctly'
    		                		
    		                );
    		                gridImage.resumeEvents();
    					}                                      
    		         }
    		);
    	}
        
        // trigger the data store load
        var alreadyImageLoaded = false;
        gridPaneImage.on("activate",function() {
    	    	if (!alreadyImageLoaded)
    	    		storeImage.load();
    	    	alreadyImageLoaded = true;
        	}
        );
      
        // second tabs built from JS
        var tabs = new Ext.TabPanel({
            activeTab: 0,
            height:500,
            plain:true,
            resizeTabs:true,
            defaults:{autoScroll: true},
            items:[
                   configForm,
                   gridPaneImage
            ]

        });
        var win = new Ext.Window({
            title    : 'Edit Parameters',
            closable : true,
            width    : 780,
            plain    : true,
            //layout   : 'border',
            items    : [tabs]
        });
        win.on('close', function(){self.location=location.href; //history.go(0);
        });

        var button = Ext.get('conf-div');
        if (button)
        	button.on('click', function(){
        		win.show(button);
        		configForm.syncSize();
        	});


        

});